@echo off
title ESD DECRYPTION
color 1f
%windir%\system32\reg.exe query "HKU\S-1-5-19" >nul 2>&1 || (
echo      -------
echo  *** WARNING ***
echo      -------
echo.
echo.
echo ADMINISTRATOR PRIVILEGES NOT DETECTED
echo ____________________________________________________________________________
echo.
echo This script require administrator privileges.
echo.
echo To do so, 'Open Command Prompt as administrator' in the current directory.
echo.
echo or right click on Command Prompt and select 'Run as administrator'
echo then change location to the script directory.
echo.
echo Press any key to exit...
pause >nul
goto :eof
)
cd /d "%~dp0"
if exist %CD%\dism\dism.exe set Path=%CD%\dism;%Path%
SET ENCRYPTEDESD=
SET ERRORTEMP=
SET DECRYPTED=0
SET WINDOWSNAME=
SET VDISK="%CD%\vdisk.vhd"

SET ENCRYPTEDESD=%~1
dism /get-wiminfo /wimfile:"%ENCRYPTEDESD%" >nul 2>&1 || (
echo.
echo Incorrect Usage or filename.
echo.
echo Usage: decrypt filename.esd
echo.
echo Press any key to exit.
pause >nul
goto :eof
)

for /f "tokens=1* delims=: " %%i in ('dism /english /get-wiminfo /wimfile:%1 /index:4 ^| find /i "Name"') do set WINDOWSNAME="%%j"
IF %ERRORLEVEL% NEQ 0 (
ECHO There is a problem reading the index name.
echo.
echo Press any key to exit.
pause >nul
goto :eof
)

for /f "tokens=2 delims=: " %%i in ('dism /english /get-wiminfo /wimfile:%1 /index:4 ^| find /i "Architecture"') do set arch=%%i
IF %ERRORLEVEL% NEQ 0 (
ECHO There is a problem reading the index architecture.
echo.
echo Press any key to exit.
pause >nul
goto :eof
)

for /f "tokens=2 delims=: " %%i in ('dism /english /get-wiminfo /wimfile:%1 /index:4 ^| find /i "Edition"') do set editionid=%%i
IF %ERRORLEVEL% NEQ 0 (
ECHO There is a problem reading the index edition id.
echo.
echo Press any key to exit.
pause >nul
goto :eof
)

for /f "tokens=1" %%i in ('dism /english /get-wiminfo /wimfile:%1 /index:4 ^| find /i "Default"') do set langid=%%i
IF %ERRORLEVEL% NEQ 0 (
ECHO There is a problem reading the index language id.
echo.
echo Press any key to exit.
pause >nul
goto :eof
)

set DVDLABEL=IR3_CCSA_%arch%FRER_%langid%_DV9
if "%editionid%"=="CoreSingleLanguage" set DVDLABEL=IR3_CSLA_%arch%FRER_%langid%_DV9
if "%editionid%"=="ProfessionalWMC" set DVDLABEL=IR3_CPWMCA_%arch%FRER_%langid%_DV9
if "%editionid%"=="CoreCountrySpecific" set DVDLABEL=IR3_CCCSA_%arch%FRER_%langid%_DV9
if "%editionid%"=="Core" set DVDLABEL=IR3_CCOA_%arch%FRER_%langid%_DV9
if "%editionid%"=="Professional" set DVDLABEL=IR3_CPRA_%arch%FRER_%langid%_DV9

:MAINMENU
cls
ECHO ===============================================================================
ECHO.                          ESD DECRYPTION SCRIPT
ECHO ===============================================================================
ECHO.                   1 - Decrypt and export to install.esd
ECHO.                   2 - Decrypt and create install.wim
ECHO.                   3 - Create Full ISO with install.esd
ECHO.                   4 - Create Full ISO with install.wim
ECHO ===============================================================================
ECHO.                            Press 'Q' to Quit
ECHO ===============================================================================

choice /c 1234q /n /m "Choose a menu option, or Q to quit: "
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP%==1 GOTO :Selection1
IF %ERRORTEMP%==2 GOTO :Selection2
IF %ERRORTEMP%==3 GOTO :Selection3
IF %ERRORTEMP%==4 GOTO :Selection4
IF %ERRORTEMP%==5 GOTO :QUIT
GOTO :MAINMENU

:Selection1
cls
IF EXIST "%CD%\install.esd" (
ECHO ===============================================================================
ECHO.  An install.esd file is already present in the current folder.
ECHO ===============================================================================
ECHO.
echo Press any key to exit.
pause >nul
GOTO :QUIT
)
Echo.
CALL :DECRYPT
ECHO ===============================================================================
Echo Exporting ESD Index 4 to a new install.esd
ECHO ===============================================================================
dism /export-image /sourceimagefile:"%ENCRYPTEDESD%" /Sourceindex:4 /destinationimagefile:install.esd /compress:recovery /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism export.)
echo.
echo Press any key to exit.
pause >nul
GOTO :QUIT

:Selection2
cls
IF EXIST "%CD%\install.wim" (
ECHO ===============================================================================
ECHO.  An install.wim file is already present in the current folder.
ECHO ===============================================================================
ECHO.
echo Press any key to exit.
pause >nul
GOTO :QUIT
)

Echo.
CALL :DECRYPT
CALL :VHDINIT
ECHO ===============================================================================
Echo Applying ESD Index 4 to a VHD for re-capture.
ECHO ===============================================================================
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:4 /applydir:Z:\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
ECHO ===============================================================================
ECHO Capturing the applied image back to a new install.wim.
ECHO ===============================================================================
imagex /capture /flags "%editionid%" /check /compress maximum Z:\ install.wim %WINDOWSNAME% %WINDOWSNAME%
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during imagex capture.)
ECHO.
echo Press any key to exit.
pause >nul
GOTO :QUIT

:Selection3
cls
Echo.
CALL :DECRYPT
ECHO.
ECHO ===============================================================================
ECHO Creating ISO structure folder...
ECHO ===============================================================================
IF EXIST ISOFOLDER\ RD /s /q ISOFOLDER\
MKDIR ISOFOLDER
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:1 /applydir:ISOFOLDER\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
del ISOFOLDER\MediaMeta.xml
ECHO.
ECHO ===============================================================================
ECHO Creating boot.wim file...
ECHO ===============================================================================
ECHO.
CALL :VHDINIT
ECHO ===============================================================================
Echo Applying ESD Index 2 to a VHD for re-capture.
ECHO ===============================================================================
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:2 /applydir:Z:\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Capturing the applied image back to a new boot.wim.
ECHO ===============================================================================
imagex /capture /flags "9" /check /compress maximum Z:\ ISOFOLDER\sources\boot.wim "Microsoft Windows PE (%arch%)" "Microsoft Windows PE (%arch%)"
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during imagex capture.&PAUSE&GOTO :QUIT)

CALL :VHDCLEAN
ECHO ===============================================================================
Echo Applying ESD Index 3 to a VHD for re-capture.
ECHO ===============================================================================
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:3 /applydir:Z:\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Appending the applied image back to boot.wim.
ECHO ===============================================================================
imagex /append /flags "2" /check /boot Z:\ ISOFOLDER\sources\boot.wim "Microsoft Windows Setup (%arch%)" "Microsoft Windows Setup (%arch%)"
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during imagex capture.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Creating install.esd file...
ECHO ===============================================================================
dism /export-image /sourceimagefile:%1 /Sourceindex:4 /destinationimagefile:ISOFOLDER\sources\install.esd /compress:recovery /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism export.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Creating ei.cfg file...
ECHO ===============================================================================
ECHO.
echo [EditionID] >ISOFOLDER\sources\EI.CFG
echo %editionid% >>ISOFOLDER\sources\EI.CFG
echo [Channel] >>ISOFOLDER\sources\EI.CFG
echo Retail >>ISOFOLDER\sources\EI.CFG
echo [VL] >>ISOFOLDER\sources\EI.CFG
echo 0 >>ISOFOLDER\sources\EI.CFG
ECHO.
ECHO ===============================================================================
ECHO Creating ISO file...
ECHO ===============================================================================
oscdimg.exe -bootdata:2#p0,e,b"ISOFOLDER\boot\etfsboot.com"#pEF,e,b"ISOFOLDER\efi\Microsoft\boot\efisys.bin" ^
-o -h -m -u2 -udfver102 ^
-t03/18/2014,09:09:28 -g ^
-l%DVDLABEL% ^
ISOFOLDER ^
%DVDLABEL%.iso
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during ISO creation.)
Echo.
echo Press any key to exit.
pause >nul
GOTO :QUIT

:Selection4
cls
Echo.
CALL :DECRYPT
ECHO.
ECHO ===============================================================================
ECHO Creating ISO structure folder...
ECHO ===============================================================================
IF EXIST ISOFOLDER\ RD /s /q ISOFOLDER\
MKDIR ISOFOLDER
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:1 /applydir:ISOFOLDER\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
del ISOFOLDER\MediaMeta.xml
ECHO.
ECHO ===============================================================================
ECHO Creating boot.wim file...
ECHO ===============================================================================
ECHO.
CALL :VHDINIT
ECHO ===============================================================================
Echo Applying ESD Index 2 to a VHD for re-capture.
ECHO ===============================================================================
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:2 /applydir:Z:\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Capturing the applied image back to a new boot.wim.
ECHO ===============================================================================
imagex /capture /flags "9" /check /compress maximum Z:\ ISOFOLDER\sources\boot.wim "Microsoft Windows PE (%arch%)" "Microsoft Windows PE (%arch%)"
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during imagex capture.&PAUSE&GOTO :QUIT)

CALL :VHDCLEAN
ECHO ===============================================================================
Echo Applying ESD Index 3 to a VHD for re-capture.
ECHO ===============================================================================
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:3 /applydir:Z:\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Appending the applied image back to boot.wim.
ECHO ===============================================================================
imagex /append /flags "2" /check /boot Z:\ ISOFOLDER\sources\boot.wim "Microsoft Windows Setup (%arch%)" "Microsoft Windows Setup (%arch%)"
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during imagex capture.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Creating install.wim file...
ECHO ===============================================================================
ECHO.
CALL :VHDCLEAN
ECHO ===============================================================================
Echo Applying ESD Index 4 to a VHD for re-capture.
ECHO ===============================================================================
dism /apply-image /imagefile:"%ENCRYPTEDESD%" /index:4 /applydir:Z:\ /checkintegrity
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during dism apply.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Capturing the applied image back to a new install.wim.
ECHO ===============================================================================
imagex /capture /flags "%editionid%" /check /compress maximum Z:\ ISOFOLDER\sources\install.wim %WINDOWSNAME% %WINDOWSNAME%
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during imagex capture.&PAUSE&GOTO :QUIT)
ECHO.
ECHO ===============================================================================
ECHO Creating ISO file...
ECHO ===============================================================================
oscdimg.exe -bootdata:2#p0,e,b"ISOFOLDER\boot\etfsboot.com"#pEF,e,b"ISOFOLDER\efi\Microsoft\boot\efisys.bin" ^
-o -h -m -u2 -udfver102 ^
-t03/18/2014,09:09:28 -g ^
-l%DVDLABEL% ^
ISOFOLDER ^
%DVDLABEL%.iso
SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (ECHO.&Echo Errors were reported during ISO creation.)
Echo.
echo Press any key to exit.
pause >nul
GOTO :QUIT

:QUIT
CALL :VHDKILL
IF EXIST ISOFOLDER\ RD /s /q ISOFOLDER\
IF EXIST %ENCRYPTEDESD%.bak (
del /f /q %ENCRYPTEDESD% >nul 2>&1
ren %ENCRYPTEDESD%.bak %ENCRYPTEDESD%
)
exit /b

:VHDKILL
IF EXIST %VDISK% (
echo select vdisk file=%VDISK% >vhd.dps
echo detach vdisk >>vhd.dps
echo exit >>vhd.dps
%windir%\system32\diskpart.exe /s vhd.dps >nul
del /f /q %VDISK%
del /f /q vhd.dps)
exit /b

:VHDINIT
CALL :VHDKILL
echo create vdisk file=%VDISK% maximum=20000 type=expandable noerr >vhd.dps
echo select vdisk file=%VDISK% >>vhd.dps
echo attach vdisk >>vhd.dps
echo create partition primary >>vhd.dps
echo format fs=ntfs quick >>vhd.dps
echo assign letter=Z >>vhd.dps
echo exit >>vhd.dps
%windir%\system32\diskpart.exe /s vhd.dps >nul

SET ERRORTEMP=%ERRORLEVEL%
IF %ERRORTEMP% NEQ 0 (
ECHO ===============================================================================
ECHO. There is a problem Creating a VHD to work with.
ECHO. PRESS ANY KEY TO EXIT.
ECHO ===============================================================================
pause >nul
GOTO :QUIT) ELSE (
ECHO ===============================================================================
ECHO.            * VHD ASSIGNED SUCCESSFULLY. Please ignore Autorun. *
ECHO ===============================================================================
ECHO.
exit /b)

:VHDCLEAN
echo select vdisk file=%VDISK% >vhd.dps
echo detach vdisk NOERR >>vhd.dps
echo attach vdisk >>vhd.dps
echo clean >>vhd.dps
echo create partition primary >>vhd.dps
echo format quick fs=NTFS >>vhd.dps
echo assign letter=Z >>vhd.dps
echo exit >>vhd.dps
%windir%\system32\diskpart.exe /s vhd.dps >nul
del /f /q vhd.dps
exit /b

:DECRYPT
IF DECRYPTED NEQ 1 (
if not exist %ENCRYPTEDESD%.bak (
Echo Backing up original esd file...
copy %ENCRYPTEDESD% %ENCRYPTEDESD%.bak >nul)
ECHO.
Echo Running Decryption program...
ECHO.
esddecrypt %ENCRYPTEDESD%
SET DECRYPTED=1
)
exit /b